package epsilonStandalone

import java.io.BufferedReader
import java.io.FileReader
import java.util.HashMap
import java.util.List
import org.eclipse.epsilon.eol.execute.context.Variable
import org.eclipse.epsilon.eol.types.EolPrimitiveType

class DNIRunner_final extends DNIRunner {
	
	public def static void main(String[] args) {
	  	
	  	val a = new DNIRunner_final()
	  	a.reset()
	  	a.start_experiment1(true)
		  	
  	}
  	
  	public def reset(){
  		simQpnParser.interestingPlaces = newLinkedList("SW40_i_SW00_rx", "SW40_i_SW00_tx",
  			
  													   "SW41_i_SW00_rx", "SW41_i_SW00_tx",
  													   "SW41_i_C12_rx", "SW41_i_C12_tx",
  													   "SW41_i_C13_rx", "SW41_i_C13_tx",
  													   
  													   "SW42_i_SW00_rx", "SW42_i_SW00_tx",
  													   "SW42_i_C17_rx", "SW42_i_C17_tx",
  													   "SW42_i_C36_rx", "SW42_i_C36_tx",
  													   
  													   "SW43_i_SW00_rx", "SW43_i_SW00_tx",
  													   "SW43_i_C37_rx", "SW43_i_C38_tx",
  													   "SW43_i_C38_rx", "SW43_i_C38_tx",
  													   
  													   
  													   "SW35_i_SW00_rx", "SW35_i_SW00_tx", "SW35_i_C39_rx", "SW35_i_C39_tx",
  													   
  													   "SW00_i_SW40_rx", "SW00_i_SW40_tx",
  													   "SW00_i_SW41_rx", "SW00_i_SW41_tx",
  													   "SW00_i_SW42_rx", "SW00_i_SW42_tx",
  													   "SW00_i_SW43_rx", "SW00_i_SW43_tx",
  													   "SW00_i_SW35_rx", "SW00_i_SW35_tx",
  													   "SW00_i_C16_rx", "SW00_i_C16_tx",
  													   
  													  	
  													   
  													   "SW40_i_C10_rx", "SW40_i_C11_rx",
  													  
  													   "SW41_i_C12_rx", "SW41_i_C12_tx",
  													   "SW41_i_SW00_rx", "SW41_i_SW00_tx",
  													   
  													   "C13a_i_C13_hypervisor_rx", "C13_hypervisor_i_C13b_rx", "Switching_of_C13_hypervisor_1029.input-place"
  													   
  													   /*
  													   "C38_i1_rx",
  													   "SW43_i_C38_tx",
  													   "SW43_i_SW00_rx",
  													   "SW00_i_SW43_tx",
  													   "SW00_i_SW41_rx",
  													   "SW41_i_SW00_tx",
  													   "SW41_i_C12_rx",
  													   "C12_i1_tx"
  													   */
  													   //"SW42_i_C17_tx", "SW42_i_C36_tx",
  													   //"SW43_i_C37_rx", "SW43_i_C38_rx"
  													   
  													   
  													   //"SW35_i2_tx", "SW35_i2_rx"
  													     //"SDN_Switching_of_SW41"
  													   )//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		
  		simQpnParser.interestingColors = newLinkedList(/*"Traffic_send_C10-to-C39",
  													   "Traffic_send_C12-to-C38",
  													   "Traffic_send_C36-to-C17",
  													   "Traffic_send_C39-to-C10",
  													   "Traffic_send_C38-to-C11",
  													   "Traffic_send_C37-to-C12",
  													   "Traffic_send_C38-to-C12",
  													   "Traffic_send_C10-to-C17"*/
  													   //"Traffic_send"
  													   )
  		simQpnParser.interestingMetrics = newLinkedList("deptThrPut")//, "deptThrPut")//, "deptThrPut")
  		
  		dniModels.clear
		qpmeModels.clear
		qpmeFiles.clear
		qpmeSimulationResultFiles.clear
		qpmeSimulationProcessedResults.clear
  		
  		dni_base_model_file = "models/scenario0A.model"
  		
  		
  	}
	
	
	public def start_experiment1(boolean simulate){
		
		var String finalResult = ""
		
		var exp2cfg = <String, String> newHashMap();
		
		var expcfgDir = "/home/mk/Documents/DNI_NEW/dni/experimentConfigs/";

		exp2cfg.put("Experiment-0_A", "0.cfg");
		exp2cfg.put("Experiment-0_B_1", "0.cfg");
		exp2cfg.put("Experiment-0_B_2", "0.cfg");
		exp2cfg.put("Experiment-0_B_3", "0.cfg");
		exp2cfg.put("Experiment-0_B_4a", "0.cfg");
		exp2cfg.put("Experiment-0_B_4b", "0.cfg");
		
		exp2cfg.put("Experiment-1_A_1client", "1A.cfg");
		exp2cfg.put("Experiment-1_A_5clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_10clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_15clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_20clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_25clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_30clients", "1A.cfg");
		exp2cfg.put("Experiment-1_A_35clients", "1A.cfg");

		exp2cfg.put("Experiment-1_B_hw_1client", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_5clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_10clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_15clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_20clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_25clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_30clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_hw_35clients", "1B.cfg");
		
		exp2cfg.put("Experiment-1_B_sw_1client", "1B.cfg");
		exp2cfg.put("Experiment-1_B_sw_2clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_sw_3clients", "1B.cfg");
		exp2cfg.put("Experiment-1_B_sw_5clients", "1B.cfg");
		
		exp2cfg.put("Experiment-1_C_native", "1C.cfg");
		
		exp2cfg.put("Experiment-1_C_hw", "1C.cfg");
		exp2cfg.put("Experiment-1_C_sw", "1C.cfg");
		
		exp2cfg.put("Experiment-2_A", "2A.cfg");
		exp2cfg.put("Experiment-2_B", "2BC.cfg");
		exp2cfg.put("Experiment-2_C", "2BC.cfg");
		
		exp2cfg.put("Experiment-3_1client", "3.cfg");
		exp2cfg.put("Experiment-3_2clients", "3.cfg");
		exp2cfg.put("Experiment-3_3clients", "3.cfg");
		
		exp2cfg.put("Experiment-4_1", "4.cfg");
		exp2cfg.put("Experiment-4_2", "4.cfg");
		exp2cfg.put("Experiment-4_3", "4.cfg");
		exp2cfg.put("Experiment-4_4", "4.cfg");
		
		exp2cfg.put("Experiment-5-50MB-Det", "5.cfg");
		exp2cfg.put("Experiment-5-50MB-Exp", "5.cfg");
		
		exp2cfg.put("Experiment-5-100MB-Det", "5.cfg");
		exp2cfg.put("Experiment-5-100MB-Exp", "5.cfg");
		
		exp2cfg.put("Experiment-5-130MB-Det", "5.cfg");
		exp2cfg.put("Experiment-5-130MB-Exp", "5.cfg");
		
		exp2cfg.put("Experiment-5-160MB-Det", "5.cfg");
		exp2cfg.put("Experiment-5-160MB-Exp", "5.cfg");
		
		exp2cfg.put("Experiment-5-200MB-Det", "5.cfg");
		exp2cfg.put("Experiment-5-200MB-Exp", "5.cfg");
		

		
		
		var String outputDir = "/home/mk/Documents/DNI_NEW/dni/DNI3/output/"
		
		var models = newLinkedList(
			/*
		 						   new ExperimentModel("Experiment-0_A", outputDir + "results/0/scenario0A.results.xml"),
								   new ExperimentModel("Experiment-0_B_1", outputDir + "results/0/scenario0B1.results.xml"),
								   new ExperimentModel("Experiment-0_B_2", outputDir + "results/0/scenario0B2.results.xml"),
								   new ExperimentModel("Experiment-0_B_3", outputDir + "results/0/scenario0B3.results.xml"),
								   new ExperimentModel("Experiment-0_B_4a", outputDir + "results/0/scenario0B4A.results.xml"),
								   new ExperimentModel("Experiment-0_B_4b", outputDir + "results/0/scenario0B4B.results.xml"),
								   
								   new ExperimentModel("Experiment-1_A_1client", outputDir + "results/1A/Experiment-1A.clients.1.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_5clients", outputDir + "results/1A/Experiment-1A.clients.5.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_10clients", outputDir + "results/1A/Experiment-1A.clients.10.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_15clients", outputDir + "results/1A/Experiment-1A.clients.15.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_20clients", outputDir + "results/1A/Experiment-1A.clients.20.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_25clients", outputDir + "results/1A/Experiment-1A.clients.25.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_30clients", outputDir + "results/1A/Experiment-1A.clients.30.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_A_35clients", outputDir + "results/1A/Experiment-1A.clients.35.zzz.results.xml"),
								   
								   new ExperimentModel("Experiment-1_B_hw_1client", outputDir + "results/1B/Experiment-1B-hw.clients.1.zzz.results.xml"),								   
								   new ExperimentModel("Experiment-1_B_hw_5clients", outputDir + "results/1B/Experiment-1B-hw.clients.5.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_10clients", outputDir + "results/1B/Experiment-1B-hw.clients.10.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_15clients", outputDir + "results/1B/Experiment-1B-hw.clients.15.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_20clients", outputDir + "results/1B/Experiment-1B-hw.clients.20.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_25clients", outputDir + "results/1B/Experiment-1B-hw.clients.25.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_30clients", outputDir + "results/1B/Experiment-1B-hw.clients.30.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_hw_35clients", outputDir + "results/1B/Experiment-1B-hw.clients.35.zzz.results.xml"),
								   
								   new ExperimentModel("Experiment-1_B_sw_1client", outputDir + "results/1B/Experiment-1B-sw.clients.1.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_sw_2clients", outputDir + "results/1B/Experiment-1B-sw.clients.2.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_sw_3clients", outputDir + "results/1B/Experiment-1B-sw.clients.3.zzz.results.xml"),
								   new ExperimentModel("Experiment-1_B_sw_5clients", outputDir + "results/1B/Experiment-1B-sw.clients.5.zzz.results.xml")
						   			*/
								   //new ExperimentModel("Experiment-1_C_native", outputDir + "results/1C/scenario1C_native.results.xml")
								   /*
								   new ExperimentModel("Experiment-1_C_hw", outputDir + "results/1C/scenario1C_hw.results.xml"),
								   new ExperimentModel("Experiment-1_C_sw", outputDir + "results/1C/scenario1C_sw.results.xml"),
								   
								   new ExperimentModel("Experiment-2_A", outputDir + "results/2/scenario2.zzz.results.xml"),
								   new ExperimentModel("Experiment-2_B", outputDir + "results/2/scenario2_B.zzz.results.xml"),
								   new ExperimentModel("Experiment-2_C", outputDir + "results/2/scenario2_C.zzz.results.xml")
								   
								   new ExperimentModel("Experiment-3_1client", outputDir + "results/3/delay_8ms/Experiment-3.clients.1.zzz.results.xml"),
								   new ExperimentModel("Experiment-3_2clients", outputDir + "results/3/delay_8ms/Experiment-3.clients.2.zzz.results.xml"),
								   new ExperimentModel("Experiment-3_3clients", outputDir + "results/3/delay_8ms/Experiment-3.clients.3.zzz.results.xml"),
								   
								   new ExperimentModel("Experiment-4_1", outputDir + "results/4/scenario_4_1.zzz.results.xml"),
								   new ExperimentModel("Experiment-4_2", outputDir + "results/4/scenario_4_2.zzz.results.xml"),
								   new ExperimentModel("Experiment-4_3", outputDir + "results/4/scenario_4_3.zzz.results.xml"),
								   new ExperimentModel("Experiment-4_4", outputDir + "results/4/scenario_4_4.zzz.results.xml")
								*/
								  new ExperimentModel("Experiment-5-50MB-Det", outputDir + "results/5/Every_5_sec/output_50.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-100MB-Det", outputDir + "results/5/Every_5_sec/output_100.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-130MB-Det", outputDir + "results/5/Every_5_sec/output_130.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-160MB-Det", outputDir + "results/5/Every_5_sec/output_160.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-200MB-Det", outputDir + "results/5/Every_5_sec/output_200.0.zzz.results.xml"),
								  
								  new ExperimentModel("Experiment-5-50MB-Exp", outputDir + "results/5/Exp_5_sec/output_50.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-100MB-Exp", outputDir + "results/5/Exp_5_sec/output_100.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-130MB-Exp", outputDir + "results/5/Exp_5_sec/output_130.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-160MB-Exp", outputDir + "results/5/Exp_5_sec/output_160.0.zzz.results.xml"),
								  new ExperimentModel("Experiment-5-200MB-Exp", outputDir + "results/5/Exp_5_sec/output_200.0.zzz.results.xml")
		)					
		
		for (m : models) {
			var experimentName = (m as ExperimentModel).experiment
			simQpnParser.interestingPlaces = parseCSVFileAsList(expcfgDir + exp2cfg.get(experimentName));
			var String result = parseResult((m as ExperimentModel).modelURI, experimentName)
			var String line = experimentName+" #\n"+result
			finalResult += line
			println(line)
			qpmeSimulationProcessedResults.add(result) 
					
			saveOutput(finalResult, outputDir + "results/"+experimentName+".final")
			
			finalResult = ""
		}	

		cleanup
	}
	
	public static def parseCSVFileAsList(String path) {
		var lst = newLinkedList();
		var br = new BufferedReader(new FileReader(path));		

	    var line = "";
	    while ((line = br.readLine()) != null) {
	       if(!line.startsWith("#"))
	       	lst.add(line);
	    }
	    
	    return lst;
	}
	
	public def start_experiment2(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut", "deptThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment2";
		var mtus = newLinkedList(1500, 1188, 888, 588, 288, 128)
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[10,20,30,40,50]){ //currently in us
				for(Integer mtu : mtus){
					i+=1
					var param_MTUsize = mtu //1500; //B
					var param_SdnSwSwitchingLatency = swlatency//3.3 //us
					var param_SdnSwSwitchingperfPPS = 10*1000 //100000;  //PPS
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.3 //us
					var param_SdnHwSwitchingperfPPS = 7.57E7 //100000;  //PPS
					var param_SdnHwSwitchingperfBPS = 101.8*1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]
		
		
		///cleanup
		cleanup
	}
	
	public def start_experiment3_3500(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment3_3500_";
		
		var ppsList = (1..100).map[v|v*100]
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[0]){ //currently in us
				for(Integer pps : ppsList){
					i+=1
					var param_MTUsize = 1500
					var param_SdnSwSwitchingLatency = swlatency
					var param_SdnSwSwitchingperfPPS = pps 
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.4
					var param_SdnHwSwitchingperfPPS = 7.57E7
					var param_SdnHwSwitchingperfBPS = 101.8// prefix G is default *1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]

		///cleanup
		cleanup
	}
	
	public def start_experiment3_2920(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment3_2920_";
		
		var ppsList = (1..20).map[v|v*100]
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[200, 300]){ //currently in us
				for(Integer pps : ppsList){
					i+=1
					var param_MTUsize = 1500
					var param_SdnSwSwitchingLatency = swlatency
					var param_SdnSwSwitchingperfPPS = pps 
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.3 
					var param_SdnHwSwitchingperfPPS = 92.2*1000000
					var param_SdnHwSwitchingperfBPS = 128// prefix G is default *1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]
		
		
		///cleanup
		cleanup
	}
}