package transformation

import com.google.inject.Injector
import org.eclipse.emf.common.util.URI
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl
import org.eclipse.emf.ecore.util.EcoreUtil
import dnimm3.impl.Dnimm3FactoryImpl
import dnimm3.impl.Dnimm3PackageImpl
import dnimm3.Dnimm3Package
import dnimm3.NetworkInfrastructure
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl
import dnimm3.*


class Transformation {
	def static void main(String[] args) {
		new Transformation().transform("spec.dnimm3")
	}
	def transform(String file){
		Resource$Factory.Registry.INSTANCE.extensionToFactoryMap.put("xmi", new XMIResourceFactoryImpl);
		Resource$Factory.Registry.INSTANCE.extensionToFactoryMap.put("dnimm3", new XMIResourceFactoryImpl); //dnimm3 is xmi
		
		val sourceUri = URI.createFileURI(file)
		val resourceSet = new ResourceSetImpl()

        // register DNIMM Model
        val packageRegistry = resourceSet.getPackageRegistry()
        packageRegistry.put(Dnimm3Package.eNS_URI, Dnimm3Package.eINSTANCE)

        val resource = resourceSet.getResource(sourceUri, true)
		val dni_root = resource.contents.get(0) as NetworkInfrastructure
		
		// how to filter and iterate over model entities
		for(e: resource.allContents.toIterable.filter(typeof(NamedElement))) {
 			println(e.name)
		}

		
		
	}
	
	
}